#ifndef _PHASECHECK_EXPORT_H_BY_JXP_20091102_EA3C3E8A_2D1C_4EF7_9A4D_AF27799B3D0A_
#define _PHASECHECK_EXPORT_H_BY_JXP_20091102_EA3C3E8A_2D1C_4EF7_9A4D_AF27799B3D0A_


// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PHASECHECKDLL_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PHASECHECKDLL_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.


#ifdef  PHASECHECKDLL_EXPORTS
    #ifdef __cplusplus
        #define SPPH_EXPORT extern "C" __declspec(dllexport)
    #else
        #define SPPH_EXPORT            __declspec(dllexport)
    #endif
#else
    #ifdef __cplusplus
        #define SPPH_EXPORT extern "C" __declspec(dllimport)
    #else
        #define SPPH_EXPORT            __declspec(dllimport)
    #endif
#endif

//////////////////////////////////////////////////////////////////////////
//
#define SPPH_API  __stdcall
//
typedef void *  SPPH_OBJECT;

//lint ++flb
typedef enum
{
    SPPH_VERSION  = 1


}SPPH_PROPERTY_OPTION;

//
typedef enum
{
    SPPH_AUTO = 0,
    SPPH_SP05,
    SPPH_SP09,
    SPPH_SP15

}SPPH_VERSION_TYPE;


//
typedef enum
{
    SPPH_SUCC  = 0,                 // ɹ
    SPPH_FAIL,                      // ʧ
    SPPH_INVALID_SPPH_OBJECT,       // Чľ: SPPH_OBJECT hObject
    SPPH_INVALID_PRODUCTINFO,       // ЧPhaseCheckṹ
    SPPH_INVALID_STATION_NAME,      // ЧĲվλ
    SPPH_STATION_NOT_EXIST,         // վ
    SPPH_STATION_NOT_PASSED,        // վδPASS
    SPPH_STATION_NOT_TESTED,        // վδ
    SPPH_CNST_PHASE_BUFFER_FAIL,    // PhaseCheckʧ
    SPPH_WRITE_PRODUCTINFO_FAIL,    // дFLASHʧ
    SPPH_READ_PRODUCTINFO_FAIL,     // ȡFLASHʧ
    SPPH_BUFFER_TOO_SMALL,          // Ļ̫С
    SPPH_READ_MAGIC_NUMBER_FAIL,    // ȡPhaseCheck汾ʧ
    SPPH_INVALID_MAGIC_VERSION      // ЧPhaseCheck汾

}SPPH_ERROR;

/* ========================================================================================================= 
-- Name:
--      CreatePhaseCheckObject
--
-- Function:
--      PhaseCheck󣬲ز
--
-- Parameter:
--  IN
--      hDiagPort: Handle of phone, returned by 'SP_CreateDiagPhone' of PhoneCommand.
--
-- Return:
--      SPPH_OBJECT: ɹزʧܷNULL.
--   
   ========================================================================================================= */

SPPH_EXPORT 
SPPH_OBJECT SPPH_API CreatePhaseCheckObject
(
    void *hDiagPort
);

/* ========================================================================================================= 
-- Name:
--      ReleasePhaseCheckObject
--
-- Function:
--      ͷCreatePhaseCheckObjectľ
--
-- Parameter:
--  IN
--      hObject:    
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR          
--   
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API ReleasePhaseCheckObject
(
    SPPH_OBJECT hObject
);

/* ========================================================================================================= 
-- Name:
--      InitPhase
--
-- Function:
--      ļãʼֻFLASHϢ
--
-- Parameter:
--  IN
--      hObject:        
--      sn1:            ֻк1NULLʼΪ0. 󳤶24ֽڡ
--      sn2:            ֻк2NULLʼΪ0. 󳤶24ֽڡ
--      pszStationName: վƣĬPASS
--  OUT
--      lpData:   ʼϵϢָ,
--                lpDataΪָ룬򲻷ݡ
--      nDataLen: lpData Bufferĳ
--      pnRetLen: ʵʷصlpData Bufferĳ      
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR          
--          
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API InitPhase
(
     SPPH_OBJECT     hObject,        /*  IN */ 
     const char     *sn1,            /*  IN */ 
     const char     *sn2,            /*  IN */ 
     LPBYTE          lpData,         /* OUT */ 
     int             nDataLen,       /*  IN */
     int            *pnRetLen,       /* OUT */
     const char     *pszStationName  /*  IN */ 
 );

/* ========================================================================================================= 
-- Name:
--      CheckPhase
--
-- Function:
--      վĲ״̬
--     
-- Parameter:
--  IN
--      hObject:                
--      pszCurrentStationName:  ǰվ
--      pszCheckStationName:    ҪĲվ
                                pszCheckStationName = "NULL", ʾվ
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR          
--          
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API CheckPhase
(
    SPPH_OBJECT hObject,                /*  IN */ 
    const char *pszCurrentStationName,  /*  IN */ 
    const char *pszCheckStationName     /*  IN */ 
 );

/* ========================================================================================================= 
-- Name:
--      UpdatePhase
--
-- Function:
--      ²վλϢ  
--
-- Parameter:
--  IN
--      hObject:        
--      pszCurrentStationName: ҪµĲվ(ͨΪǰվ)
--      nState:         ״̬1 ʾ PASS; 0 ʾ FAIL  
--      pszLastDescription:    ״̬󲻳32ֽ
--      sn1:            SN1, ָΪ򲻸SN1
--      sn2:            SN2, ָΪ򲻸SN2
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR        
--          
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API UpdatePhase
(
    SPPH_OBJECT hObject,                /*  IN */ 
    const char *pszCurrentStationName,  /*  IN */ 
    int         nState,                 /*  IN */ 
    const char *pszLastDescription,     /*  IN */   //Max characters is 32.
    const char *sn1,                    /*  IN */ 
    const char *sn2                     /*  IN */ 
);

/* ========================================================================================================= 
-- Name:
--      PutProperty
--
-- Function:
--      
--
-- Parameter:
--  IN
--      hObject:     
--      lOption:    ѡ
--      lProperty:  ֵ 
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR       
--          
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API PutProperty
(
    SPPH_OBJECT hObject,    /*  IN */ 
    LONG        lOption,    /*  IN */ 
    LONG        lProperty   /*  IN */ 
);

/* ========================================================================================================= 
-- Name:
--      GetProperty
--
-- Function:
--      ȡ
--
-- Parameter:
--  IN
--      hObject:     
--      lOption:    ѡ
--  OUT
--      pProperty:  ֵ 
--
-- Return:
--      ɹSPPH_SUCCοSPPH_ERROR       
--          
   ========================================================================================================= */

SPPH_EXPORT 
DWORD SPPH_API GetProperty
(
    SPPH_OBJECT hObject,    /*  IN */ 
    LONG        lOption,    /*  IN */ 
    LONG       *pProperty   /* OUT */
);

/* ========================================================================================================= 
-- Name:
--      SPPH_GetLastError/SPPH_GetLastErrorMessage
--
-- Function:
--      һεĴʹϢ 
--
-- Parameter:
--  IN
--      hObject:    
--      pMsgBuff:   洢Ϣ
--      nBuffLen:   С
--      nLangOption:1, ; 0, Ӣ
--
-- Return:
--      SPPH_GetLastError ɹһεĴ
--              
--          
   ========================================================================================================= */
SPPH_EXPORT 
DWORD SPPH_API SPPH_GetLastError
(
    SPPH_OBJECT hObject     /*  IN */
);

SPPH_EXPORT
DWORD SPPH_API SPPH_GetLastErrorMessage
(
    SPPH_OBJECT hObject,    /*  IN */
    char       *pMsgBuff,   /* OUT */
    int         nBuffLen,   /*  IN */
    int         nLangOption /*  IN */
);
//lint --flb
#endif /* _PHASECHECK_EXPORT_H_BY_JXP_20091102_EA3C3E8A_2D1C_4EF7_9A4D_AF27799B3D0A_ */
