// WriteFlash.h : main header file for the WRITEFLASH application
//

#if !defined(AFX_WRITEFLASH_H__45CE1FC4_81FA_4B6E_BF84_30CE9C2BC6B9__INCLUDED_)
#define AFX_WRITEFLASH_H__45CE1FC4_81FA_4B6E_BF84_30CE9C2BC6B9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "phdef.h"
#include "XAboutDlg.h"
#include "IDCS.h"
#include "PhoneCommand.h"
/////////////////////////////////////////////////////////////////////////////
// CWriteFlashApp:
// See WriteFlash.cpp for the implementation of this class
//
#define BT_ADDR_STR_LENGTH			13    //also wifi lenth

typedef enum
{
    GENCODE_TYP_MANUAL  = 0,  // manual input or use the scanner
	GENCODE_TYP_AUTGEN,       // auto generation (system time)
	GENCODE_TYP_AUTADD        // auto generation (addr plus) 
        
}GCODIMEI_E;

typedef struct _Write_Flash_Para
{
    BOOL	bChkIMEI;
	BOOL	bChkIMEI2;
    BOOL	bChkIMEI3;
    BOOL    bChkIMEI4;
//  ## zijian.zhu @ 20111212 for NEWMS00147831 <<<	
	GCODIMEI_E eGenIIMEI1;
	GCODIMEI_E eGenIIMEI2;
	GCODIMEI_E eGenIIMEI3;
	GCODIMEI_E eGenIIMEI4;
//  ## zijian.zhu @ 20111212 for NEWMS00147831 >>>
   	BOOL	bChkAutoIMEI;
	BOOL	bChkUseSameIMEI;
   	BOOL	bChkPhase;
    BOOL	bChkBTAddr;
	BOOL	bChkAutoCreateBT;
    BOOL    bCheckWifi;
    BOOL    bChkAutoCreateWifi;
	BOOL    bCheckMAC; // һֽ bit0, bit1
    int     nMocver;
    BOOL    bSaveIMEI;
    BOOL    bSaveToTxt;
    BOOL    bCheckRepeat;  //ظ
    BOOL    bCheckValid;   //Ϸ
    BOOL    bCheckVer;
	int     nVerLenLowLimit;
    CString sAutoIMEI;
    CString sVersion;
    CString sForeWifi;
//  ## zijian.zhu @ 20111103 for NEWMS00133531(Yihu requirement) <<<	
	BOOL    bGenBtAddrType;  // FALSE: Time; TRUE: Initial Addr;
	BOOL    bGenWifiMacType;  // FALSE: Time; TRUE: Initial Addr;
	CString strInitAddrForBT;
	CString strEndAddrForBT;
	CString strInitAddrForWifi;
	CString strEndAddrForWifi;
	BOOL    bEnableSNFunc;
	BOOL    bChkSN1;
	BOOL    bChkSN2;
	BOOL    bChkAutoSN1;
	BOOL    bChkAutoSN2;
//  ## zijian.zhu @ 20111103 for NEWMS00133531(Yihu requirement) >>>
	
//  ## zijian.zhu @ 20120414 for NEWMS00185078 <<<
    BOOL    bChkIMEIAfterRead;
//  ## zijian.zhu @ 20120414 for NEWMS00185078 >>>

//  ## zijian.zhu @ 20120725 for NEWMS00226697 <<<
    BOOL    bManualAssignBtAddr;
	CString strBtAddrPath;
    BOOL    bManualAssignWifiAddr;
	CString strWifiAddrPath;
//  ## zijian.zhu @ 20120725 for NEWMS00226697 >>>


	//teana hu 2012.10.16
	CString strAPVerRead;
	CString strAPVerInput;
	BOOL bChkAPVer;
	//

    _Write_Flash_Para()
    {
        memset(this,0,(DWORD)(&(this->sAutoIMEI)) - (DWORD)(&(this->bChkIMEI)));
        sAutoIMEI=_T("");
    }

	//teana hu 2013.08.15
	BOOL	bChkShark;
	int		nSharkIndex;
	//

	//teana hu 2014.01.17
	BOOL	bChkSecureBoot;
	//

	//teana hu 2014.03.05
	BOOL	bChkPowerOff;
	//
	//teana hu 2014.04.02
	BOOL	bChkAPMode;
	//

	//teana hu 2014.10.08
	BOOL	bChkProgramKey;
	//

	//teana hu 2014.05.12
	BOOL	bReadBack;
	//

	//get Chip UID  2017/4/24
	BOOL    bReadUID;

	//
	//teana hu 2015.01.28
	int		m_nProgramKeyIndex;
	//

	//teana hu 2015.07.09
	BOOL	bChkPreventSteal;
	//

	//teana hu 2015.07.30
	BOOL	bChkReset;
	//

	//wei.song 20160225
	WORD	wChkMMICITFlag;
	BOOL	bChkChipLifeCycles;
	BOOL	bChkChipRepairState;
	//

	//teana hu 2016.02.16
	CString strWideVinePath;
	BOOL	bChkWideVine;

	//teana hu 2016.03.30
	BOOL	bSecurityScheme;

	//teana hu 2016.06.15
	BOOL	bChkSimlock;

	//Simlock config, wei.song 20161103
	TCHAR szSimlockConfig[50];

}WriteFlashPara;

//wei.song 20160225
typedef struct 
{
	char type_id; //----wholephonetest0 /PCBA function test1/BBAT Auto test2
	char funtion_id; //   ----63ֲԹܣ0-63
	char support; //-----------Ƿ֧,eng ʼʱȡcmdline еӦbitmask֧֧
	char status; //   --------ԽengʼʱͳһΪ00: no  test. 01:pass, 02:fail
}TEST_NEW_RESULT_INFO;
//

typedef struct _Custom_BtAddr_Comp
{
	TCHAR szStarAddr[MAX_BT_ADDR_STR_LENGTH];
	TCHAR szCurrAddr[MAX_BT_ADDR_STR_LENGTH];
	TCHAR szStopAddr[MAX_BT_ADDR_STR_LENGTH];
	
}CustomBtAddrComp;

typedef struct _Custom_WifiAddr_Comp
{
	TCHAR szStarAddr[MAX_WIFI_ADDR_STR_LENGTH];
	TCHAR szCurrAddr[MAX_WIFI_ADDR_STR_LENGTH];
	TCHAR szStopAddr[MAX_WIFI_ADDR_STR_LENGTH];
	
}CustomWifiAddrComp;

typedef struct _secureboot_block_t 
{
	DWORD wBlockID;
	DWORD dwBody;
}SECURE_BOOT_BLOCK_T;

class CWriteFlashApp : public CWinApp
{
public:
	CWriteFlashApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWriteFlashApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CWriteFlashApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
    CString m_strVersion;
    CString m_strBuild;
private:
    HINSTANCE      m_hResModule;

	void GetVersion();
    
    void ReleaseResLib(void);
    BOOL ChangeLanguage(void);

};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITEFLASH_H__45CE1FC4_81FA_4B6E_BF84_30CE9C2BC6B9__INCLUDED_)





















